/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: trace_config.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ȥ졼ǽ
 */

#include "kernel_impl.h"
#include "task.h"

#include "target_timer.h"

/*
 *  trace_config.h˥ץȥ֤٤TCB
 *  ʤΤǡѥ뤬̤ʤᤳ֤
 */
extern void log_dsp_enter(const TCB *p_tcb);
extern void log_dsp_leave(const TCB *p_tcb);

/*
 *  ؿץȥ
 */
static StatusType trace_wri_log(TRACE *p_trace);

/*
 *  ȥ졼ХåեȤ˥뤿Υݥ
 */
static TRACE			trace_buffer[TCNT_TRACE_BUFFER];    /* ȥ졼Хåե */
static uint32			trace_count;                        /* ȥ졼ХåեΥο */
static uint32			trace_head;                         /* ƬΥȥ졼γǼ */
static uint32			trace_tail;                         /* Υȥ졼γǼ */
static TraceModeType	trace_mode = TRACE_STOP;            /* ȥ졼⡼ɽ */

/*
 *  ȥ졼ǽν
 */
void
trace_initialize(uintptr exinf)
{
	TraceModeType mode = ((TraceModeType) exinf);

	trace_count = 0U;
	trace_head = 0U;
	trace_tail = 0U;
	trace_mode = mode;
}

/*
 *  ȥ졼γ
 */
StatusType
trace_sta_log(TraceModeType mode)
{
	if ((mode & TRACE_CLEAR) != 0U) {
		trace_count = 0U;
		trace_head = 0U;
		trace_tail = 0U;
	}
	trace_mode = mode;
	return(E_OK);
}

/*
 *  ȥ졼ν
 */
static StatusType
trace_wri_log(TRACE *p_trace)
{
	CoreIdType coreid = x_core_id();
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	if (trace_mode != TRACE_STOP) {

		/*
		 *  ȥ졼
		 *
		 *  LOG_WRI_LOG_ENTERƤФ줿p_trace->logtim񤭴
		 *  ƤޤΤϵwri_logǾ񤭤뤿
		 *  Ϥʤ
		 */
		p_trace->logtim = GET_UTIM();

		/*
		 *  ȥ졼Хåե˵Ͽ
		 */
		trace_buffer[trace_tail] = *p_trace;
		trace_buffer[trace_tail].coreid = coreid;
		trace_tail++;
		if (trace_tail >= TCNT_TRACE_BUFFER) {
			trace_tail = 0U;
		}
		if (trace_count < TCNT_TRACE_BUFFER) {
			trace_count++;
			if ((trace_count >= TCNT_TRACE_BUFFER)
				&& ((trace_mode & TRACE_AUTOSTOP) != 0U)) {
				trace_mode = TRACE_STOP;
			}
		}
		else {
			trace_head = trace_tail;
		}
	}

	SIL_UNL_SPN();
	return(E_OK);
}

/*
 *  ȥ졼ɽФ
 */
StatusType
trace_rea_log(TRACE *p_trace)
{
	StatusType ercd;
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	/*
	 *  ȥ졼ХåեμФ
	 */
	if (trace_count > 0U) {
		*p_trace = trace_buffer[trace_head];
		trace_count--;
		trace_head++;
		if (trace_head >= TCNT_TRACE_BUFFER) {
			trace_head = 0U;
		}
		ercd = E_OK;
	}
	else {
		ercd = E_NOT_OK;
	}

	SIL_UNL_SPN();
	return(ercd);
}

/*
 *  ȥ졼Ϥ뤿Υ饤֥ؿ
 */

void
trace_write_0(uint32 type)
{
	TRACE trace;

	trace.logtype = type;
	(void) trace_wri_log(&trace);
}

void
trace_write_1(uint32 type, const uintptr arg1)
{
	TRACE trace;

	trace.logtype = type;
	trace.loginfo[0] = arg1;
	(void) trace_wri_log(&trace);
}

void
trace_write_2(uint32 type, uintptr arg1, uintptr arg2)
{
	TRACE trace;

	trace.logtype = type;
	trace.loginfo[0] = arg1;
	trace.loginfo[1] = arg2;
	(void) trace_wri_log(&trace);
}

void
trace_write_3(uint32 type, uintptr arg1, uintptr arg2, uintptr arg3)
{
	TRACE trace;

	trace.logtype = type;
	trace.loginfo[0] = arg1;
	trace.loginfo[1] = arg2;
	trace.loginfo[2] = arg3;
	(void) trace_wri_log(&trace);
}

void
trace_write_4(uint32 type, uintptr arg1, uintptr arg2, uintptr arg3,
			  uintptr arg4)
{
	TRACE trace;

	trace.logtype = type;
	trace.loginfo[0] = arg1;
	trace.loginfo[1] = arg2;
	trace.loginfo[2] = arg3;
	trace.loginfo[3] = arg4;
	(void) trace_wri_log(&trace);
}

void
trace_write_5(uint32 type, uintptr arg1, uintptr arg2, uintptr arg3,
			  uintptr arg4, uintptr arg5)
{
	TRACE trace;

	trace.logtype = type;
	trace.loginfo[0] = arg1;
	trace.loginfo[1] = arg2;
	trace.loginfo[2] = arg3;
	trace.loginfo[3] = arg4;
	trace.loginfo[4] = arg5;
	(void) trace_wri_log(&trace);
}

/*
 *  ֥ǵҤ륳ɤȥ졼Ϥ뤿δ
 *  
 */
void
log_dsp_enter(const TCB *p_tcb)
{
	trace_1(LOG_TYPE_DSP | LOG_ENTER, (const uintptr) p_tcb);
}

void
log_dsp_leave(const TCB *p_tcb)
{
	trace_1(LOG_TYPE_DSP | LOG_LEAVE, (const uintptr) p_tcb);
}
