/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: interrupt.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		⥸塼
 */

#include "kernel_impl.h"
#include "interrupt.h"
#include "mc.h"

#ifdef TOPPERS_interrupt_initialize

/*
 *  ߴǽν
 */
#ifndef OMIT_INITIALIZE_INTERRUPT

void
interrupt_initialize(void)
{
	ISRType				i;
	InterruptNumberType	j;
	ISRCB				*p_isrcb;
	const INTINIB		*p_intinib;
	CoreIdType			coreid = x_core_id();

	/* C2ISRICISRν */
	for (i = 0U; i < tnum_isr2; i++) {
		if (isrinib_table[i].p_osapinib->coreid == coreid) {
			p_isrcb = p_isrcb_table[i];
			p_isrcb->p_isrinib = &(isrinib_table[i]);
			p_isrcb->p_lastrescb = NULL;
			p_isrcb->p_lastspncb = NULL;
		}
	}

	for (j = 0U; j < tnum_intno; j++) {
		p_intinib = &(intinib_table[j]);
		x_config_int(p_intinib->intno, p_intinib->intatr, p_intinib->intpri, p_intinib->coreid);
	}
}

#endif /* OMIT_INITIALIZE_INTERRUPT */
#endif /* TOPPERS_interrupt_initialize */

/*
 *  ߶ػߤβ
 */
#ifdef TOPPERS_release_interrupts

void
release_interrupts(OSServiceIdType serviceId)
{
#ifdef CFG_USE_ERRORHOOK
	boolean call_error_hook = FALSE;
#endif /* CFG_USE_ERRORHOOK */
	CCB		*p_ccb = get_my_p_ccb();

	if (p_ccb->sus_os_cnt_ctx > 0U) {
		p_ccb->sus_os_cnt -= p_ccb->sus_os_cnt_ctx;
		p_ccb->sus_os_cnt_ctx = 0U;

		if (p_ccb->sus_os_cnt == 0U) {
			LEAVE_CALLEVEL(TSYS_SUSOSINT);
			x_nested_unlock_os_int();
		}
#ifdef CFG_USE_ERRORHOOK
		call_error_hook = TRUE;
#endif /* CFG_USE_ERRORHOOK */
	}

	if (p_ccb->sus_all_cnt_ctx > 0U) {
		p_ccb->sus_all_cnt -= p_ccb->sus_all_cnt_ctx;
		p_ccb->sus_all_cnt_ctx = 0U;
		if (p_ccb->sus_all_cnt == 0U) {
			LEAVE_CALLEVEL(TSYS_SUSALLINT);
			ASSERT((p_ccb->callevel_stat & TSYS_DISALLINT) == TSYS_NULL);
			x_unlock_all_int();
		}
#ifdef CFG_USE_ERRORHOOK
		call_error_hook = TRUE;
#endif /* CFG_USE_ERRORHOOK */
	}

	/* C2ISRξΤDisAll */
	if (serviceId == OSServiceId_ISRMissingEnd) {
		if ((p_ccb->callevel_stat & TSYS_DISALLINT) != TSYS_NULL) {
			LEAVE_CALLEVEL(TSYS_DISALLINT);
			x_unlock_all_int();
#ifdef CFG_USE_ERRORHOOK
			call_error_hook = TRUE;
#endif /* CFG_USE_ERRORHOOK */
		}
	}

#ifdef CFG_USE_ERRORHOOK
	if ((serviceId != OSServiceId_Invalid) && (call_error_hook != FALSE)) {
		call_errorhook(E_OS_DISABLEDINT, serviceId);
	}
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_release_interrupts */

/*
 *  C2ISRλΥåؿ
 */
#ifdef TOPPERS_exit_isr2

/*
 *  C2ISR꥽ֵ
 */
LOCAL_INLINE void
release_isrresources(ISRCB *p_isrcb)
{

	/* OS߶ػ߾ְʾϤ */
	if (p_isrcb->p_lastrescb != NULL) {
		do {
			x_set_ipm(p_isrcb->p_lastrescb->prevpri);
			p_isrcb->p_lastrescb->lockflg = FALSE;
			p_isrcb->p_lastrescb = p_isrcb->p_lastrescb->p_prevrescb;
		} while (p_isrcb->p_lastrescb != NULL);

#ifdef CFG_USE_ERRORHOOK
		call_errorhook(E_OS_RESOURCE, OSServiceId_ISRMissingEnd);
#endif /* CFG_USE_ERRORHOOK */
	}
}

/*
 *  C2ISRԥåֵ
 */
LOCAL_INLINE void
release_isrspinlocks(ISRCB *p_isrcb)
{
	SPNCB *p_spncb;

	p_spncb = p_isrcb->p_lastspncb;

	/* OS߶ػ߾ְʾϤ */
	if (p_spncb != NULL) {
		do {
			acquire_spn_lock(GET_SPNLOCK());

			p_spncb->p_ccb = NULL;
			p_isrcb->p_lastspncb = p_spncb->p_prevspncb;
			p_spncb->p_prevspncb = NULL;
			p_spncb->p_holdcb = NULL;

			release_spn_lock(GET_SPNLOCK());

			if (p_spncb->p_spninib->resint != NULL) {
				p_spncb->p_spninib->resint();
			}
			p_spncb = p_isrcb->p_lastspncb;
		} while (p_spncb != NULL);

#ifdef CFG_USE_ERRORHOOK
		call_errorhook(E_OS_SPINLOCK, OSServiceId_ISRMissingEnd);
#endif /* CFG_USE_ERRORHOOK */
	}
}

void
exit_isr2(void)
{
	CCB *p_ccb = get_my_p_ccb();

	x_nested_lock_os_int();

	/* ԥåޤޤξϥԥå */
	release_isrspinlocks(p_ccb->p_runisr);

	release_interrupts(OSServiceId_ISRMissingEnd);

	/* ꥽ݾ֤ξ */
	release_isrresources(p_ccb->p_runisr);
	x_nested_unlock_os_int();
}

#endif /* TOPPERS_exit_isr2 */
